/*
  Extras - Library for Extras class.
  Created by Simon Jansen, 2013-04-05.
  Released into the public domain.
  changelog:
  2025-04-23:	LoopsPerSec unsigned long instead of unsigned int
*/

#include "Extras.h"
#include "Arduino.h"

const byte DEFAULTPINBLINKLED = 9;
const unsigned long INTERVALTIME = 500;

Extras::Extras(){
  _pinBlinkLED = DEFAULTPINBLINKLED;
  pinMode(_pinBlinkLED,OUTPUT);
  _blinkState = true;
  _interValTimer = millis();
  _LoopsPerSecCounter = 0;
  LoopsPerSec = 0;
}

Extras::Extras(byte _pinBlinkLED){
  pinMode(_pinBlinkLED,OUTPUT);
  _blinkState = true;
  _interValTimer = millis();
  _LoopsPerSecCounter = 0;
  LoopsPerSec = 0;
}

void Extras::Update(){
  if (millis() > _interValTimer + INTERVALTIME) { //interval
    _interValTimer = millis();       		//Set last time data was stored in buffer
    if (_blinkState){
      digitalWrite(_pinBlinkLED, HIGH);		//Turn LED on
      _blinkState = false;
      LoopsPerSec = _LoopsPerSecCounter;	//Expose the number of loops to public
      _LoopsPerSecCounter = 0;				//Reset private counter
    }
    else{
      digitalWrite(_pinBlinkLED, LOW);		//Turn LED off
      _blinkState = true;
    }
  }
  _LoopsPerSecCounter++;					//Count number of loops privately
}